#modulo di utilita' che modella gli oggetti carta e mazzo

class Carta:
  ''' definisco un nuovo tipo di dati. Questa classe rappresenta UNA carta del mazzo di briscola'''

  def __init__(self,seme=0,valore=0):
    self.seme=seme
    self.valore=valore

  def __str__(self):
    semi = ("Bastoni","Coppe","Denari","Spade")
    valori = ("niente","Asso","2","3","4","5","6","7","Fante","Cavallo","Re")
    return (valori[self.valore] + " di " + semi[self.seme])

  # confronto, utile per capire se due carte sono uguali
  # richiesto dal metodo remove() di una lista
  def __cmp__(self,other):
    if self.seme > other.seme: return 1 
    if self.seme < other.seme: return -1 
    # stesso seme
    if self.valore > other.valore: return 1 
    if self.valore < other.valore: return -1 
    # stesso valore 
    return 0

  def Punti(self):
    ''' ritorna il valore in punti della carta '''
    punteggi = (0,11,0,10,0,0,0,0,2,3,4)
    return punteggi[self.valore]
  

class Banco:
  'questa classe rappresenta un mazzo, un insieme generico di carte'
  def __init__(self):
    self.carteinmano = []
    for seme in range(4):
      for valore in range(1,11):
        self.carteinmano.append(Carta(seme,valore))
  
  def Stampa(self):
    for carta in self.carteinmano: print carta

  # mescola il mazzo
  def Mescola(self):
    import random 
    n = len(self.carteinmano) 
    for i in range(n): 
      j = random.randrange(i, n) 
      self.carteinmano[i], self.carteinmano[j] = self.carteinmano[j], self.carteinmano[i]

  #rimuove una specifica carta dal mazzo (utile se si gioca in 3)
  def Togli(self,carta):
    if carta in self.carteinmano:
      self.carteinmano.remove(carta)
      return 1
    return 0

  def EstraiCarta(self):
    """toglie e ritorna l'ultima carta del mazzo"""
    return self.carteinmano.pop()

  def Vuoto(self):
    return (len(self.carteinmano) == 0)

  # distribuisce nCarte ad un giocatore. "gioc" e' un oggetto di tipo Giocatore()
  def DaiCarte(self, gioc, nCarte=1): 
    for i in range(nCarte): 
      if self.Vuoto(): break      # esci se mazzo vuoto
      carta = self.EstraiCarta()  # prende la prima carta
      gioc.AggiungiCarta(carta)   # aggiunge la carta alla mano

def Vincente(c1,c2,briscola=None):
  ''' accetta 3 oggetti Carta
  ritorna 0 se vince la prima carta, 1 se vince la seconda'''
  if c1.seme == c2.seme:
    if c1.Punti() > c2.Punti():	return 0
    if c1.Punti() < c2.Punti(): return 1
    if c1.valore > c2.valore: return 0
    if c1.valore < c2.valore: return 1
  if c2.seme == briscola.seme: return 1
  return 0
    
